
#include "dungeon.h"

void Dungeon::BuildDungeon(int numFloors)
{
	
	floor_list.assign(numFloors, Floor(4,15,10,10,64,64,5,0));
	
	for (int i=0; i<numFloors; i++){
	
			floor_list[i].generateFloor();

	}
	
}

void Floor::generateFloor(){
	
	uint8_t roomCount=0;
	uint8_t currentRoom=0;
	vec2 currentTile;
	currentTile.x=0;
	currentTile.y=0;
	bool stairGen = false;
	
	int check=0;
	
	std::vector<vec2> roomStarts;
	
	bool drawingRoom=false;
	
	for (int x=0; x<128; x++){
		for (int y=0; y<128; y++){
			baseTileMap[x][y]=0;
		}
	}
	
	
	while (roomCount<constructors.numRooms){
			if (currentTile.x!=0 && currentTile.y!=0 && currentTile.x!=constructors.floorDimensions.x-1 && currentTile.y!=constructors.floorDimensions.y-1){
				
				bool qualifies=true;
				
				if (baseTileMap[currentTile.x][currentTile.y]==0){
					for (int x=currentTile.x; x<currentTile.x+constructors.maxRoomSize.x; x++){
						for (int y=currentTile.y; y<currentTile.y+constructors.maxRoomSize.y; y++){
							if (baseTileMap[x][y]!=0){
								qualifies=false;
							}
						}
					}
					
					if (qualifies==true){
						
						int randNo=rand()%100;
						
						if (randNo<constructors.roomDensity){
							
							vec2 roomStart = {currentTile.x, currentTile.y};
							roomStarts.push_back(roomStart);
							
							for (int x=currentTile.x; x<currentTile.x+constructors.maxRoomSize.x; x++){
								for (int y=currentTile.y; y<currentTile.y+constructors.maxRoomSize.y; y++){
									
									randNo=rand()%100;
									
									if (randNo<=93){
										
										
										baseTileMap[x][y]=1;
										
										randNo = rand()%100;
										if (randNo >= 95 && stairGen == false)
										{
											baseTileMap[x][y] = 7;
											stairLocation.x = x;
											stairLocation.y = y;
											stairGen = true;
										}
									}
									else{
										baseTileMap[x][y]=2;
									}
								}
							}
							
							
							
							for (int x=currentTile.x; x<currentTile.x+constructors.maxRoomSize.x; x++){
								baseTileMap[x][currentTile.y-1]=3;
								baseTileMap[x][currentTile.y+constructors.maxRoomSize.y]=6;
							}
							for (int y=currentTile.y; y<currentTile.y+constructors.maxRoomSize.y; y++){
								baseTileMap[currentTile.x-1][y]=4;
								baseTileMap[currentTile.x+constructors.maxRoomSize.x][y]=5;
							}
												
							roomCount++;
						}
					}
					
					
					
				}
			
			}
			
			currentTile.x++;
					
			if (currentTile.x>=constructors.floorDimensions.x){
				currentTile.x=0;
				currentTile.y++;
			}
	}
	
	for (int x=0; x<128; x++){
		for (int y=0; y<128; y++){
			if (baseTileMap[x][y]==1){
				if (enemy_list.size()<constructors.numEnemies){
					int randNo=rand()%100;
					if (randNo>=97){
						enemy_list.push_back(new Slime());
						enemy_list[enemy_list.size()-1]->Initialize(x, y, 20, 2, 0, 32, 36, 40, 1, 2, "Slime");
					}
				}
			}
		}
	}
	
	for (int i = 1; i<roomStarts.size(); i++)
	{
		int tempX = roomStarts[0].x;
		int tempY = roomStarts[0].y;
		while (tempY<(roomStarts[i].y+1))
		{
			if (baseTileMap[tempX][tempY]!=1 && baseTileMap[tempX][tempY]!=2 &&  baseTileMap[tempX][tempY]!=7)
			{
				baseTileMap[tempX][tempY] = 1;
				baseTileMap[tempX-1][tempY] = 4;
				baseTileMap[tempX+1][tempY] = 5;
			}
				tempY++;
		}
		
		while (tempX<(roomStarts[i].x+1))
		{
			if (baseTileMap[tempX][tempY]!=1 && baseTileMap[tempX][tempY]!=2 && baseTileMap[tempX][tempY]!=7)
			{
				baseTileMap[tempX][tempY] = 1;
				baseTileMap[tempX][tempY-1] = 3;
				baseTileMap[tempX][tempY+1] = 6;
			}
			tempX++;
		}
	}
}

Floor::Floor(uint8_t rooms, uint8_t density, int roomX, int roomY, int floorX, int floorY, uint8_t enemies, uint8_t loot){
	constructors.numRooms=rooms;
	constructors.roomDensity=density;
	constructors.maxRoomSize.x=roomX;
	constructors.maxRoomSize.y=roomY;
	constructors.floorDimensions.x=floorX;
	constructors.floorDimensions.y=floorY;
	constructors.numEnemies=enemies;
	constructors.numLoot=loot;
}



			