#ifndef DUNGEON_H
#define DUNGEON_H

#include <string>
#include <vector>
#include <cstdlib>

#include "enemy.h"
#include "utility.h"

struct genDetails {
    
    uint8_t numRooms;
	uint8_t roomDensity;
    vec2 maxRoomSize;
	vec2 floorDimensions;
    
    uint8_t numEnemies;
    uint8_t numLoot;
	
};

struct listItem { 
	
	vec2 position;
	std::string type;
	std::string name;


};

class Floor 
{
	
	public:
	
		genDetails constructors;
		
		vec2 stairLocation;
		
		uint8_t baseTileMap[128][128];
		
		std::vector<Enemy*> enemy_list;
	
		std::vector<vec2> roomStarts;
	
	Floor (uint8_t,uint8_t,int,int,int,int,uint8_t,uint8_t);
	void generateFloor();
	
};

class Dungeon 
{
	
	public:
	
		std::vector<Floor> floor_list;
	
		void BuildDungeon(int numFloors);
};

#endif /* DUNGEON_H */