#include <stdint.h>
#include <vector>

#include "gba.h"


#include "utility.h"
#include "gamecontrol.h"
#include "dungeon.h"
#include "player.h"
#include "weapons.h"
#include "armours.h"
#include "trinkets.h"

//#include "class/ability/abilities.h"

// An empty (transparent) tile.
const uint8_t blank_tile[64] = {
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0,
};

// The entry point for the game - The part where we add the exploding Bulbasaurs
int main()
{
    
	
	
	GameControl gameControl;
	
	gameControl.Initialize();
	
	
	LoadTile8(0,14,blank_tile);
	
	std::vector <Trinket> trinket_list;
	std::vector <Weapon> weapon_list;
	std::vector <Armour> armour_list;
	
	int displayedFloor=0;
	
	createWeaponList(weapon_list);
	createArmourList(armour_list);
	createTrinketList(trinket_list);
	
	Dungeon dungeon1;
	dungeon1.BuildDungeon(1);
	
	player_character player(1,1,1,3,1,1);
	
	player.Initialize(weapon_list, armour_list, trinket_list);
	
	
	SetPaletteBG(0, RGB(0,0,0));
	
	//Main game loop - PUT ALL OF THIS INTO DIFFERENT FUNCTIONS AT SOME POINT!!! - Code tests currently

	ClearObjects();
	
	SetObject(0,
	          ATTR0_SHAPE(0) |  ATTR0_8BPP | ATTR0_REG | ATTR0_Y(80),
			  ATTR1_SIZE(1) | ATTR1_X(112),
			  ATTR2_ID8(16));
			  
	for (int i = 0; i<dungeon1.floor_list[displayedFloor].enemy_list.size(); i++)
	{		
		SetObject(i+1,
				  ATTR0_SHAPE(0) | ATTR0_8BPP | ATTR0_HIDE | ATTR0_REG | ATTR0_Y(dungeon1.floor_list[displayedFloor].enemy_list[i]->current_position.y),
				  ATTR1_SIZE(1) | ATTR1_X(dungeon1.floor_list[displayedFloor].enemy_list[i]->current_position.x),
				  ATTR2_ID8(dungeon1.floor_list[displayedFloor].enemy_list[i]->frontSprite) | ATTR2_PRIO(3));
	}
	
	while (true)
	{
		
		FlipBuffers();
		
		uint16_t currentKeys = REG_KEYINPUT;
		
		if (gameControl.playerTurn ==true)
		{
			if (gameControl.menuOpen == false)
			{
				gameControl.PlayerHandler(currentKeys, player,  dungeon1.floor_list[displayedFloor]);
			}
			else
			{
				gameControl.MenuHandler(currentKeys, player, dungeon1.floor_list[displayedFloor]);
			}
			
			if((currentKeys&KEY_B) == 0)
			{
				gameControl.OpenMenu();
			}
		
		}
		else
		{
			gameControl.EnemyHandler(player, dungeon1.floor_list[displayedFloor]);
		}
			
		gameControl.CalculateLightMap(player);
		gameControl.RenderUI(player, dungeon1.floor_list[displayedFloor]);
		gameControl.RenderPlayer(player);		
		gameControl.RenderWorld(dungeon1.floor_list[displayedFloor], player.draw_position.x, player.draw_position.y);
		gameControl.RenderEnemies(dungeon1.floor_list[displayedFloor], player);
		
		UpdateObjects();
		
		for (int i=0;i<5;i++){
			gameControl.PlayMusic(dungeonTune);
			gameControl.numSyncs++;
			WaitVSync();
		}
	}

	return 0;
}
