#ifndef PLAYER_H
#define PLAYER_H

#include <string>
#include <vector>

#include "utility.h"
#include "weapons.h"
#include "armours.h"
#include "trinkets.h"


using namespace std;

class Ability;

struct item_storage 
{
	std::string itemName;
	std::string itemType;
	int itemWeight;
};

class player_character {
	
	private:
	
		int MAX_CARRY, MAX_EXP;
			
		int LEVEL;
		
		int STR, DEX, WILL, VIT;
		
		int protection, base_protection;
		int attack, base_attack;
		
		std::string weapon;
		std::string armour;
		std::string trinket;
		
		std::string character_class;
		
		
		std::vector<item_storage> item_list;

		
		void CALC_MAX_HP (std::vector<Weapon> &weapon_list, std::vector<Armour> &armour_list, std::vector<Trinket> &trinket_list);
		void CALC_MAX_CARRY (std::vector<Weapon> &weapon_list, std::vector<Armour> &armour_list, std::vector<Trinket> &trinket_list);
		void CALC_PROTECTION (std::vector<Weapon>& weapon_list, std::vector<Armour> &armour_list, std::vector<Trinket>& trinket_list);
		void CALC_ATTACK (std::vector<Weapon> &weapon_list, std::vector<Armour> &armour_list, std::vector<Trinket> &trinket_list);
		
	public:
	
		vec2 draw_position;
		vec2 current_position;
		
		int frontSprite, sideSprite, backSprite;
		
		int MAX_HP, MAX_AP;
		int hp, carry, exp, ap;
		bool TORCH_EQUIPPED;
		
		direction target_direction;
		
		std::vector<Ability*> ability_list;
		
		player_character(int strength, int dexterity, int willpower, int vitality, int protection, int attack);
		
		int ReturnAttack();
		void Initialize(std::vector<Weapon> &weapon_list, std::vector<Armour> &armour_list, std::vector<Trinket> &trinket_list);
		void ADD_ABILITY(Ability* ability);
		void Add_Item(item_storage item);
		void MOVE(direction);
		int USE_ABILITY(int i);
		bool TakeDamage(int damage);
};

#include "abilities.h"

#endif /* PLAYER_H */